<template>
    <q-page class="bg-base">
        <Container :max-height="1">
            <DocumentWrapper ref="doc" class="relative-position">
                <template>
                    <div v-if="floorplans.length === 0">
                        <AnimationComponent text="There are currently no floorplans"
                                            :animation="$animations.emptyBox"
                                            :max-height="1"/>
                    </div>
                    <ListPage v-else>
                        <q-list separator bordered>
                            <FloorPlanItem v-for="(f, i) in floorplans" :key="i"
                                           :floor-id="routeParams.floorId" :floorplan="f" :latest="i === 0"/>
                        </q-list>
                    </ListPage>
                </template>
            </DocumentWrapper>
            <div>
                <q-btn round size='lg' color="accent" icon="add" class="absolute-bottom-right q-ma-lg"
                       :to="`/floor/${routeParams.floorId}/floorplan/create`">
                    <q-tooltip anchor="center left" self="center right">
                        Create a new floorplan
                    </q-tooltip>
                </q-btn>
            </div>
        </Container>

    </q-page>
</template>

<style lang='scss' scoped>

</style>

<script lang='ts'>
import {Component, Vue} from 'vue-property-decorator';
import DocumentWrapper from "components/Core/DocumentWrapper.vue";
import {FloorPlanPrincipalResponse} from "src/classLibrary/APIModels/core/floorPlanPrincipalResponse";
import AnimationComponent from "components/Core/AnimationComponent.vue";
import FloorPlanItem from "components/Entities/List/FloorPlanItem.vue";
import {SortType} from "@kirinnee/core";
import Container from "components/Core/Container.vue";
import ListPage from "components/Core/ListPage.vue";

@Component({
    components: {ListPage, Container, FloorPlanItem, AnimationComponent, DocumentWrapper}
})
export default class FloorPlanList extends Vue {
    floorplans: FloorPlanPrincipalResponse[] = [];

    routeParams = {
        floorId: '',
    }

    async load() {
        const p = this;
        const t = await this.$auth.CoreToken;
        const r = await this.$coreApi.Get<FloorPlanPrincipalResponse[]>(`Floorplan/${this.routeParams.floorId}?projectId=${this.PersistentStore.StoreValue.project}`, null, t);

        r.match({
            err: (e) => (p.$refs.doc as any).SubmitError(e),
            ok: (o) => {
                console.info(o);
                p.floorplans = o.Sort(SortType.Descending, x => x.timeStamp as any);
            }
        })

    }

    async init() {
        await this.load();
    }
}
</script>
